--[[
New version of the hider bar module

]]--

if not pcall(function() import "JackdawPlugins.Bevy2.Isil" end) then
	--Default colour scheme if Isil.lua is not present.
	BackColor=				Turbine.UI.Color(1,0,0,0)
	ButtonBackColor = 		Turbine.UI.Color(1,0,0,0.5)
	TooltipColor=			Turbine.UI.Color(0.5,0,0,0)
	TooltipLabelBackColor=	Turbine.UI.Color( 0.5, 0, 0,0)
	TooltipLabelForeColor=	Turbine.UI.Color(0.85, 0.69, 0.23)
	ForeColor=				Turbine.UI.Color(0.85, 0.69, 0.23)
	Opac=0.9
end

if type(Modules.hider)~="table" and Modules.hider~=nil then
	--First load - set defaults
	Modules.hider={}
	Modules.hider.x=0
	Modules.hider.y=0
end

--Create the Bar
	Hider={}
	Hider.Window=Turbine.UI.Window()
	Hider.Window:SetVisible(true)
	Hider.Window:SetPosition(Modules.hider.x,Modules.hider.y)
	Hider.Window.DragBar = Deusdictum.UI.DragBar( Hider.Window,"Hider Bar")
	Hider.Window:SetBackColor 		( BackColor)
	
	Hider.Window.PositionChanged=function (sender,args)
		Modules.hider.x,Modules.hider.y=Hider.Window:GetPosition()
	end

--Create the tooltip
	Hider.Tooltip=Turbine.UI.Window()
	Hider.Tooltip:SetVisible(false)
	Hider.Tooltip:SetBackColor  ( TooltipColor)
	Hider.Tooltip:SetSize(150,20)
	Hider.Tooltip.Label=Turbine.UI.Label()
	Hider.Tooltip.Label:SetSize(150,20)
	Hider.Tooltip.Label:SetBackColor( TooltipLabelBackColor)
	Hider.Tooltip.Label:SetForeColor( TooltipLabelForeColor )
	Hider.Tooltip.Label:SetFont(Turbine.UI.Lotro.Font.Verdana16)
	Hider.Tooltip.Label:SetParent(Hider.Tooltip)
	Hider.Tooltip.Label:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter )

--Create the Buttons - this is a function
Hider.Button={}
	
function BarUpdate()
--Delete the Buttons! This is to avoid errors when bars are created or destroyed.
	
	for i,v in pairs(Hider.Button) do
		Hider.Button[i]:SetVisible(false)
		Hider.Button[i]=nil 
	end
	
--Create the buttons
local j=0	--Counts the number of buttons
	for i=1,#Bar do
		if not(Bar[i].delete) then
			if Bar[i].Data.hider~=nil then
				j=j+1
				Hider.Button[i]=Turbine.UI.Button() 
				Hider.Button[i] :SetPosition			( 12*(j-1)+10,1)
				Hider.Button[i] :SetSize					( 10,10 )
				Hider.Button[i] :SetVisible 				( true )
				Hider.Button[i] :SetOpacity				( Opac )
				Hider.Button[i] :SetParent				( Hider.Window )
				Hider.Button[i] :SetBackColor 		( ButtonBackColor )
				 
					if Bar[i].Data.hider.vis then
						Hider.Button[i] :SetText					("O ")
						Bar[i]:Show()
					else
						Hider.Button[i] :SetText					("X ")
						Bar[i]:Hide()
					end

				Hider.Button[i].MouseDown = function( sender, args )
					if Bar[i].Data.hider.vis then 
						Hider.Button[i] :SetText ("X ")
						Bar[i].Data.hider.vis=false
						Bar[i]:Hide()
					else
						Hider.Button[i] :SetText ("O ")
						Bar[i].Data.hider.vis=true
						Bar[i]:Show()
					end
				end
				Hider.Button[i].MouseEnter = function (sender,args)
					local x=Turbine.UI.Display.GetMouseX()
					local w,h=Turbine.UI.Display.GetSize()
					local x=x-75
					local y=Modules.hider.y-20
					if x<0 			then x=0 end
					if x+150>w 	then x=w-150 end
					if y<0			then y=Modules.hider.y+12 end
					Hider.Tooltip:SetVisible(true)
					Hider.Tooltip:SetPosition(x,y)
					Hider.Tooltip.Label:SetText(Bar[i].Data.name)
				end
				Hider.Button[i].MouseLeave = function (sender,args)
					Hider.Tooltip:SetVisible(false)
				end
			end
		end
	end
	Hider.Window:SetSize(20+12*j,12)
end

--Context Menu function
table.insert(Context,
function (self,contextMenu,contextMenuItems)
--Add the "Hider Bar" option to every Bar.
	local HiderBar = Turbine.UI.MenuItem( "Hider Bar Button for "..self.Data.name,true,self.Data.hider~=nil);
	HiderBar.Click = function( sender, args )
		if self.Data.hider==nil then
			self.Data.hider={}
			self.Data.hider.vis=true
		else
			self.Data.hider=nil
		end
		BarUpdate()
	end
	contextMenuItems:Add( HiderBar )	
end)

--Option Box functions

table.insert(Opt.Module,
	function()
		Opt.Hider=CollapseBox("Hider Bar Options","f",1,true)
		Opt.ListBox:AddItem(Opt.Hider)
	
			Opt.hider=Opt.CheckBox("Hider?",function(k,i) 
			if k then
				Bar[i].Data.hider={}
				Bar[i].Data.hider.vis=true
			else
				Bar[i].Data.hider=nil
			end

			BarUpdate()
		end )
		Opt.Hider.Content:AddItem(Opt.hider)
		table.insert(Opt.source,"hider")
		Opt.table.hider=true

		end)

BarUpdate()	